#include "chess.h"


struct lex{
  char *name;
  char *value;
  struct lex *next;
};

static struct lex *dict=0;
static char empty_str[] = "";
static unsigned char prkey[] = 
{84, 104, 105, 115, 32, 112, 114, 111, 103, 
 114, 97, 109, 109, 32, 105, 115, 32, 119, 
 114, 111, 116, 101, 32, 98, 101, 32, 69, 
 46, 32, 75, 111, 114, 110, 105, 108, 111, 
 102, 102, 32, 97, 110, 100, 32, 109, 111, 
 100, 105, 102, 121, 32, 83, 46, 78, 105, 
 102, 111, 110, 116};

//-------------------------------------------
int property_load(char fname[])
{
  const char del[] = "=\"";
  FILE *f = fopen(fname,"r");
  char s[256];
  char *name, *value;
 
 
 
  if(f)
  {
     while(fgets(s, sizeof(s)-1, f))
     {
       #ifdef OBENDER_DEBUG
                 printf("#----->  property_load, s=%s\n", s);
       #endif     
       if(s[0] != '#') // comment
       {
        name = strtok(s, del);
        if(name)
        {
           value = strtok(0, del);
           if(value)
           {
              struct lex *p =  (struct lex*)
                               malloc(sizeof(struct lex));
              p->name = strdup(name);
              p->value = strdup(value);
              p->next = dict;
              dict = p;
              
              #ifdef OBENDER_DEBUG
                 printf("#----->  property_load: name=\"%s\"; value=\"%s\" \n",
                         p->name, p->value);
              #endif
           }
        }
       } 
     }//while
     fclose(f);
     return 1;
  }
  return 0;
}


char* property_get(char name[])
{
  struct lex *p;
  
  for(p = dict; p; p = p->next)
    if(strstr(p->name,name))  // 
      return p->value;
  

  return empty_str;
}

void property_add(char name[], char value[])
{
      struct lex *p =  (struct lex*)
                               malloc(sizeof(struct lex));
      p->name = strdup(name);
      p->value = strdup(value);
      p->next = dict;
      dict = p;
}



