#include "chess.h"


extern int atk[16*16],dir_atk[16*16];
//extern const int center;


//#define MOB_CIRCLE   // experement. 
                     //  variant mobility + hung + isol_pawn score




// char set  cyr.  Win 1251
int value[7] = {0,VALUE_P,VALUE_N,VALUE_B,VALUE_R,VALUE_Q,VALUE_K};
int score_table[2][8][64];
extern int history[2][8][64];



/*
  piece score = (BONUS-X)  + tbl[sq] + MOB&ATK  + MATERIAL
                   |          |
                 mid        InitEvaluate
                 value       0..32 (>?) 
*/

#define ROOK_BONUS   40     // + --> end game
#define KNIGHT_BONUS 50     // - --> end game
#define BISHOP_BONUS (60-6) // (-6) - for inc. mobile, + --> 2B
#define QUEEN_BONUS  110    // if 1 queen ---> (-)

const int add_st_value[7] = {0,0,KNIGHT_BONUS, BISHOP_BONUS,ROOK_BONUS, QUEEN_BONUS};


const int PASSED_PAWN_ROW[2][8] =
{
  {0,64,32,16,8,4,2,0},
  {0,2,4,8,16,32,64,0}
};

//0004
int rank[2][8]={{7,6,5,4,3,2,1,0},{0,1,2,3,4,5,6,7}};


const  int comp_value[] = {0,1,3,3,5,10,20};
#define CNTRL_PAWN   (1<<15)
#define CNTRL_KNIGHT (1<<14)
#define CNTRL_BISHOP (1<<13)
#define CNTRL_ROOK   (1<<12)
#define CNTRL_QUEEN  (1<<11)
#define CNTRL_KING   (1<<10)
const int piece_cntrl[] = {0,CNTRL_PAWN,CNTRL_KNIGHT,CNTRL_BISHOP,
                           CNTRL_ROOK,CNTRL_QUEEN,CNTRL_KING};
const int comp_piece_cntrl[] = {0,CNTRL_PAWN,CNTRL_KNIGHT,CNTRL_KNIGHT,
                           CNTRL_ROOK,CNTRL_QUEEN,CNTRL_KING};
const int pawn_start_row[8] = {NEUTRAL, BLACK, NEUTRAL, NEUTRAL,
                               NEUTRAL, NEUTRAL,WHITE,NEUTRAL};
#define PAWN_START_POS(sq,c)  ( pawn_start_row[ROW(sq)]==c )
const int opponent_board[] = {WHITE,WHITE,WHITE,WHITE,
                              BLACK,BLACK,BLACK,BLACK};
const int main_diag[64] = {
  2,1,0,0,0,0,1,2,
  1,2,1,0,0,1,2,1,
  0,1,2,1,1,2,1,0,
  0,0,1,2,2,1,0,0,
  0,0,1,2,2,1,0,0,
  0,1,2,1,1,2,1,0,
  1,2,1,0,0,1,2,1,
  2,1,0,0,0,0,1,2

};

const int center_tbl[64] = {
  
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 1, 1, 1, 1, 1, 1, 0,
  0, 1, 3, 3, 3, 3, 1, 0,
  0, 1, 3, 4, 4, 3, 1, 0,
  0, 1, 3, 4, 4, 3, 1, 0,
  0, 1, 3, 3, 3, 3, 1, 0,
  0, 1, 1, 1, 1, 1, 1, 0,
  0, 0, 0, 0, 0, 0, 0, 0
  
};



struct Atk_Type{
  int bit_atk[64];
  //double math_atk[64];

} p_attack[2];



int max(int v1, int v2) {  return v1 > v2 ? v1 : v2; }
int min(int v1, int v2) {  return v1 < v2 ? v1 : v2; }


/*
int abs(int v){
  return v >= 0 ? v : (-v);
}
*/
int Distance(int v1, int v2){

  return max(abs(ROW(v1)-ROW(v2)),
             abs(COLUMN(v1)-COLUMN(v2)));
}


int Taxi(int sq0, int sq1)
{
   return abs(COLUMN(sq0)-COLUMN(sq1)) + abs(ROW(sq0)-ROW(sq1));
}

int get_less(int atk)
{
  int j;
  
  for(j = CNTRL_PAWN; j >= CNTRL_KING; j >>= 1)
   if(atk & j)
    return j;
  return 0;
}



/***
  opponent mtl enemy -  N,B,R,Q --->   (0..1)
  if 0 then  king thret = 0
***/
double Stage(int c){
   const int EMTL = 14 + 2*6 + 2*4 + 2*3;
    int *op_cnt = g.cnt[c^1];
    int emtl = op_cnt[QUEEN]*14 +
               op_cnt[ROOK]*6 +
               op_cnt[BISHOP]*4 +
               op_cnt[KNIGHT]*3;

    if(emtl <= 4) emtl = 0;
    if(emtl > EMTL) emtl = EMTL;
    return (double)emtl / EMTL;
}


/*
  фигурная угроза ладье
  учитываются слоны и кони оппонента
  4    - max
  2B   - +
  < 2  - 0
  
  return 0..4
*/   
//0005
int stage_nb_int(int my_side){
  const int tbl[] = { 0,0,1, 3, 4, 4, 4, 4, 4, 4, 4, 4 };
  const int tbl1[]= { 0,0,1,1,1,1,1,1,1,1,1,1,1,1};
  int *cnt = g.cnt[my_side^1];
  return  min(4,
              tbl[cnt[BISHOP] + cnt[KNIGHT]]  +
              tbl1[cnt[BISHOP]]);
}   

/***********
double StageKnightBishop(int c){
   const EMTL =  2*4 + 2*3;   // 14
   int *v = g.cnt[c ^ 1],
        cnt  =  v[BISHOP] + v[KNIGHT],
        emtl = v[BISHOP]*4 +
               v[KNIGHT]*3;
    if( cnt <= 1 ) return 0;
    if( cnt == 2 ) emtl -= 2;

    if(emtl > EMTL) emtl = EMTL;
    return (double)emtl / EMTL;
}
**************/



/*
  генерирует таблицы средних значений 
  для фигур
*/
//0005
void InitEvaluate(void){
 void  GenScoreTable(int p, int tbl[64], int c, int max, int op_king_sq);
 int p,c,j;
 const int D = 1; // threat on opponent side
 
  const int blackPawnScore[64] =  // Jon Stanback pawn score
   { 0,     0,   0,   0,   0,   0,   0,   0,
     4,     4,   4,   0,   0,   4,   4,   4,
     6,     8,   2,  10,  10,   2,   8,   6,
     6,     8,  12,  16,  16,  12,   8,   6,
     8-D,  12-D,16-D,24-D,24-D,16-D,12-D, 8-D,
    12-D,  16-D,24-D,32-D,32-D,24-D,16-D,12-D,
    12  ,  16  ,24  ,32  ,32  ,24  ,16  ,12  ,
     0,     0,   0,   0,   0,   0,   0,   0};


                        //   P  N  B  R  Q  K 
 const int MaxTableValue[] =  {0,32,34,32,32,32,36};
                            

                                              // NBRQ SCORE
 for(c = WHITE; c <= BLACK; c++){
   for(p = KNIGHT; p <= KING; p++)
      GenScoreTable(p,score_table[c][p],c,MaxTableValue[p],
      g.kingSq[c^1]);

 }


                                               // PAWN SCORE   
 for(j = 0; j < 64; j++){
    score_table[BLACK][PAWN][j] =  blackPawnScore[j];
    score_table[WHITE][PAWN][j] =  blackPawnScore[63-j];
 }
 

 for(c = WHITE; c <= BLACK; c++){              // KING_SCORE_INIT
    const int king_file[] = {0,0,3,4,4,3,0,0};
    double stage = Stage(c);
    int j;


    if(g.cnt[c][PAWN]==0) stage = 0; 

    for(j = 0; j < 64; j++){
      double tmp = score_table[c][KING][j];
      if(stage > 0.5) tmp += king_file[COLUMN(j)];

      score_table[c][KING][j] =  -tmp*stage + tmp*(1.0-stage);
    }
 }

}






int print_score_tbl()
{

 do{
    void PrintArray(FILE*f,int tbl[64], int p, int c);
    FILE *f = fopen("sctable.txt","w");
    int p,c;

    for(c = WHITE; c <= BLACK; c++)
     for(p = PAWN; p <= KING; p++)
       PrintArray(f, score_table[c][p], p, c);

    fclose(f);

 }while(0);
 return 0;
}



int maxHungValue[2];


int Evaluate(int alpha, int beta){
  const int MARGIN = 500;

  int s[2];

  maxHungValue[WHITE] = maxHungValue[BLACK] = 0;
  
  s[WHITE] = g.mtl[WHITE];
  s[BLACK] = g.mtl[BLACK];

  if( (g.cnt[WHITE][PAWN]  | g.cnt[BLACK][PAWN])==0  &&
      (g.cnt[WHITE][QUEEN] | g.cnt[BLACK][QUEEN])==0 &&
      (g.cnt[WHITE][ROOK ] | g.cnt[BLACK][ROOK])==0  &&
       g.cnt[WHITE][BISHOP] * 4   +   g.cnt[WHITE][KNIGHT] * 3   <  4+3 &&
       g.cnt[BLACK][BISHOP] * 4   +   g.cnt[BLACK][KNIGHT] * 3   <  4+3 )
       return 0;

  if(s[g.side] - s[g.xside] + MARGIN <= alpha  ||
     s[g.side] - s[g.xside] - MARGIN >= beta)
     return s[g.side] - s[g.xside];

 // s[0] = s[1] = 0;
//  s[0] /= 10;
//  s[1] /= 10;

  do{
    void GenerateAttackes(void);
    int  Mobile_Pin_XRay(int sq, int p, int c, int* a0, int* a1, int *mob);
    int KingSFTY(int c);
    int c,i,sq,p,dP,*b_atk0, *b_atk1,c1,hungCnt,score;//,st_score;
    double stage,__stage;

    GenerateAttackes();
    for(c = WHITE; c <= BLACK; c++){
      int passiv_piece_cnt = 0;
      int isolCnt = 0;
      int doubleCnt = 0;
      dP = c==WHITE ? -8:8;
      c1 = c^1;
      b_atk0 = p_attack[c].bit_atk;
      b_atk1 = p_attack[c1].bit_atk;
      hungCnt = 0;
      score = 0;
      //st_score = 0;
      stage = Stage(c);
      __stage = 1.0 - stage;
      
      
      for(i = g.start[c]; i <= g.stop[c]; i++)
       if( (sq = g.list[i]) != -1 ){
         int b0,b1;

         p = g.pos[sq];
         score += score_table[c][p][sq];

         // cntrl_bishop = cntrl_knight
         b0 = (b_atk0[sq]&~CNTRL_BISHOP) | ((b_atk0[sq]&CNTRL_BISHOP) << 1);
         b1 = (b_atk1[sq]&~CNTRL_BISHOP) | ((b_atk1[sq]&CNTRL_BISHOP) << 1);

         
         // 0001
         
         
         if(b1)
         { //attacked
         
            score -= b1&15; // count attack 
            
            // note safe OR attacker < piece
            if(b0==0  ||  ((~(comp_piece_cntrl[p] - 1)<<1)  &  b1) ){
               
              maxHungValue[c] = max(  maxHungValue[c], value[p] );
//0003              
              score -= 4;
              ++hungCnt;
              if(hungCnt==2) score -= 6;
              if(p==PAWN) score -= 1;
              
            }else{
   //00011         
              if( p == PAWN )
               if( (b0 & CNTRL_PAWN)==0 )          //<--- +
                if( (b1 & 15) > (b0 & 15) )
                  score -= 1; // attack on bad pawn ?
                  
              // atk < def                  


              if( comp_piece_cntrl[get_less(b1)] >  //<----+
                  comp_piece_cntrl[get_less(b0)] )
                  score -= 1;
    
            }
          }
          

          if(p==PAWN){
          
             int x = COLUMN(sq);
             int half_passed = g.pawn_column_cnt[c1][x]==0;

             if(half_passed)  score += 1;
             
             if((b_atk0[sq+dP]&CNTRL_PAWN)==0) score -= 1; // not friend pawn
             
             if(g.color[sq+dP] == c1) score -= 2; // op. bloked
             

             if(g.pawn_column_cnt[c][x] > 1)   //double
             {
                 ++doubleCnt;
                 score -= 2;
                 if(doubleCnt==3) score -= 6;                 
             }    

                                        // isol
             if( (x==0 || g.pawn_column_cnt[c][x-1]==0) &&
                 (x==7 || g.pawn_column_cnt[c][x+1]==0) ) {
               ++isolCnt;
               score -= 8;
               if(isolCnt==3) score -= 6;
                
             }
             
             //0004
             //if(opponent_board[ROW(sq)]==c) <--- in InitEval
             //  score -= 1; // threat op.
             

             do{                            // PASSED ?
               const int bonus[2][8] = 
               {
                { 0, 64, 32, 16, 8, 4, 2, 0 },
                { 0, 2,  4,  8, 16,32,64, 0 } 
               };
               int u = sq + dP;
               while( (unsigned)u < 64 ){
                 if(b_atk1[u] &  CNTRL_PAWN) goto notPassedPawn;
                 if(g.pos[u]==PAWN && g.color[u]==c1) goto notPassedPawn;
                 u += dP;
               }
               score += 12 + bonus[c][ROW(sq)];
               
               
               // protected  passed pawn -> is very good!
               if( (b_atk0[sq] & CNTRL_PAWN)  ||
                   (b_atk0[sq+dP] & CNTRL_PAWN) )
                   score += 4;

              //0004
              // rook backward and pawn on op.board
              if( b_atk0[sq] & CNTRL_ROOK )
               if( b_atk0[sq-dP] & CNTRL_ROOK )
                if(opponent_board[ROW(sq)]==c)
                 score += 4;    
               
                                  
              //end game     
              if(stage==0  &&  g.cnt[c1][KNIGHT]+g.cnt[c1][BISHOP]+g.cnt[c1][ROOK]==0)
              {

                 int destSq = c==WHITE? COLUMN(sq) :  8*7 + COLUMN(sq);
                 if( Distance(sq,destSq) < Distance(destSq, g.kingSq[c1]) ){ //������� ����� - 100% ��������!!!
                    score += PASSED_PAWN_ROW[c][ROW(sq)] << 3; 
                 }
              }

           notPassedPawn:
              score += 0;
             }while(0);





           }else if(p==KING){          // KING_SCORE
              
              //int tmp = score_table[c][KING][sq];
              
              //score -= tmp;
              
              //score += -tmp * stage  +  tmp * (1.0 - stage);



              score += KingSFTY(c);


             



           }else{// other pieces
           
           
           //0004
               if(p==ROOK){               //------------ SCORE_ROOK
               
               
                 const int rook_column_tbl[] =
		 {
		    0,0,1,1,1,1,0,0
		 };
		 int mob = 0;
		 
		 
		 score += rook_column_tbl[COLUMN(sq)];
                 score += ROOK_BONUS;
                 score += Mobile_Pin_XRay(sq,p,c,b_atk0,b_atk1,&mob);
                 score += abs(COLUMN(sq) - COLUMN(g.kingSq[c1]))>>1;
                 score += 10 * __stage;  
                 if(b0 & CNTRL_ROOK)     score += 1;
                 if(g.cnt[c][ROOK] > 1 ) score += 1;


                 if(g.pawn_column_cnt[c][COLUMN(sq)]==0)
                 {
                    score += 4;  //open line
                    if(g.pawn_column_cnt[c1][COLUMN(sq)]==0)
                     score += 6; //operation line
                 }   
                  
                 switch(rank[c][ROW(sq)])  //0..7
                 {
                   case 0: score += 1; break;
                   case 6:
                       if( g.pawn_row_cnt[c1][rank[c][6]] ||
                           rank[c][ROW(g.kingSq[c1])]==7)
                           score += 8;
                   break;
                 }                 
                 
                 
                 if(mob < 16/3) 
                   passiv_piece_cnt++; 
                 

                 
                // score +=  ((14-Taxi(sq, g.kingSq[c1]))>>1)
                //            * __stage;
                 
                 
                 
                 
                 
               }else if(p==BISHOP){ //   SCORE_BISHOP
                 int mob;
        //0005          
                 score += BISHOP_BONUS;
                 score += Mobile_Pin_XRay(sq,p,c,b_atk0,b_atk1,&mob);
                 if(g.cnt[c][BISHOP]>1) score += 8;
                 score += main_diag[sq];
                 
                 if(mob <= 2)
                   passiv_piece_cnt++;

               }
               
               
               
               
               else if(p==QUEEN){    //  SCORE_QUEEN
               
               
                 int cnt;
                 score += QUEEN_BONUS;
                 
                 score += Mobile_Pin_XRay(sq,p,c,b_atk0,b_atk1,0);
                 
                 if(b0 & CNTRL_ROOK) score += 1;
                 if(b_atk0[sq] & CNTRL_BISHOP) score += 1;
                 
                 if(Distance(sq, g.kingSq[c]) > 2)  score -= 1;
                 
                 if(Distance(sq, g.kingSq[c1]) <= 3){
                    score += 5;//10*(0.5 + (1.0-StageKnightBishop(c)) * 0.7);
                 }
                 
                 score += (14 - Taxi(sq, g.kingSq[c1]))/2;
                 
                 cnt = g.cnt[c][ROOK] + g.cnt[c][BISHOP] + g.cnt[c][KNIGHT];
                 
                 if( cnt > 0 ){
                   score += 2;
                   if( cnt > 1 ) score += 4; 
                 }
                 
                 
                 /****************************
                                              // like rook      //?1
                 if( (g.pawn_column_cnt[WHITE][COLUMN(sq)] |
                      g.pawn_column_cnt[BLACK][COLUMN(sq)])==0 
                   )
                   score += 1;                // operation line //?!
                 
                 if(c==WHITE)
                 {
                   if(ROW(sq)==1) score += 1; // rank 7
                 }else{
                   if(ROW(sq)==6) score += 1;
                 }
                 ****************************/
                 
                 
               }
               
               
               else if(p==KNIGHT){       // SCORE_KNIGHT
               
               
                  score += KNIGHT_BONUS;
                  
                  if(b_atk0[sq] & CNTRL_KNIGHT) score += 1;
                  
                 // if( Distance(sq, g.kingSq[c1]) <= 3 )
                 //   score += 4;
                 
                  score += (7-Distance(sq, g.kingSq[c1]));
                  score -=  8-(g.cnt[WHITE][PAWN] + g.cnt[BLACK][PAWN])/2;
                  
                  
                  if(b0 & CNTRL_PAWN) score += 1; // outpost ?
               
                  
                  if(center_tbl[sq]==0)    // 
                    passiv_piece_cnt++;
                  
               }
           }
       }//end if sq != -1

       
       //score += (g.cnt[c][PAWN]) * __stage;
       
       score -= 8 - g.cnt[c][PAWN];
       if(g.cnt[c][PAWN]==0) score -= 16;
       


/*******       
       const passiv_tbl[] = // {0, 1, 4, 10, 20, 30, 36, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38};
                            //   {0, 1, 4, 8, 14, 22, 30, 36, 40, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42};
                            
                               {0, 0, 1, 3, 5, 8, 12, 17, 23, 30, 38, 47, 50, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60};
       
       score -= passiv_tbl[passiv_piece_cnt]; // 
*******/


       //score -= passiv_piece_cnt*passiv_piece_cnt/2;	       
       //if(passiv_piece_cnt)
       //  score -= passiv_piece_cnt-1;

    //0004
     do{  // нет центральных пешек ? (против сдваивания)
       const int tbl[] = {0,-1,-3}; 
       int t = 0;
       if(g.pawn_column_cnt[c][COLUMN(D4)]==0)
         t++;       
       if(g.pawn_column_cnt[c][COLUMN(E4)]==0)
         t++;       
       score += tbl[t];
       
       //0004
       //лишняя фигура помогает выиграть пешку
       if(g.cnt[WHITE][PAWN] | g.cnt[BLACK][PAWN])
       {
         int ec[2];
         ec[WHITE] = g.cnt[WHITE][KNIGHT] + g.cnt[WHITE][BISHOP] + 
                     g.cnt[WHITE][ROOK] + g.cnt[WHITE][QUEEN];

         ec[BLACK] = g.cnt[BLACK][KNIGHT] + g.cnt[BLACK][BISHOP] + 
                     g.cnt[BLACK][ROOK] + g.cnt[BLACK][QUEEN];
                     
         if(ec[c] > ec[c1])
          score += 2;            
       }
         
     }while(0);    
         
       
       s[c] += score;
      
     }//for c				 


  }while(0);


  return s[g.side] - s[g.xside];

}


void  GenScoreTable(int p, int tbl[64], int c, int max, int op_king_sq){


   if(p != PAWN){
      int tmp[64],j,cnt,d,u,n1,max_val,sq;

      for(j = 0; j < 64; j++){
        int row = c==BLACK? ROW(j) : (7 - ROW(j));
        tbl[j] = row;
      //  if(p != KING)
      //    tbl[j] += 14 - Taxi(j,op_king_sq);
        tmp[j] = 0;
      }
      max_val = 0;
      for(cnt = 0; cnt < 3; cnt++){
        for(sq = 0; sq < 64; sq++)
          for(d = d_start[p]; d <= d_stop[p]; d++)
            for(n1 = MAP(sq)+ dir[d]; (n1&0x88)==0; n1 += dir[d]){
              u = UNMAP(n1);
              tmp[sq] += tbl[u];
              if(tmp[sq] > max_val) max_val = tmp[sq];
              if(!SWEEP(p)) break;
            }
        //copy
        for(j = 0; j < 64; j++)
          tbl[j] = tmp[j];
      }
      //zoom result
      for(j = 0; j < 64; j++)
        tbl[j] = (unsigned)tbl[j] * max / max_val;

   }else{ //PAWN
    int CntAtkPromoteSq(int sq, int c);
    int PromotePathLen(int sq, int c);
    double temp[64], max_val = 0;
    int j;

    for(j = 0; j < 64; j++)
      if(ROW(j) != 0  &&  ROW(j) != 7){
        temp[j] = (double)CntAtkPromoteSq(j,c) /
                  PromotePathLen(j,c);
        if(temp[j] > max_val) max_val = temp[j];
      }else temp[j] = 0;
    for(j = 0; j < 64; j++)
      tbl[j] = temp[j] * max / max_val;
   }

}


int CntAtkPromoteSq(int sq, int c){
 int x1,y1,x2,y2,dY;
  //left
  x1 = COLUMN(sq); y1 = ROW(sq);
  dY = c==WHITE? -1:1;
  do{
    x1 -= 1; y1 += dY;
  }while(x1 >= 0 && x1 <= 7 && y1 >= 0 && y1 <= 7);

  //right
  x2 = COLUMN(sq); y2 = ROW(sq);
  dY = c==WHITE? -1:1;
  do{
    x2 += 1; y2 += dY;
  }while(x2 >= 0 && x2 <= 7 && y2 >= 0 && y2 <= 7);

  return x2 - x1 + 1;

}

int PromotePathLen(int sq, int c){
  if(c==WHITE) return ROW(sq);
  else return 7 - ROW(sq);
}

void PrintArray(FILE*f,int tbl[64], int p, int c){
  char *chp[] = {"nopiece","pawn","knight","bishop",
                 "rook","queen","king"};
  char *chc[] = {"white","black"};
  int x,y;

  fprintf(f, "%s %s\n", chc[c], chp[p]);

  for(y = 0; y < 8; y++){
    for(x = 0; x < 8; x++){
      int j = y*8+x;

      fprintf(f,"%3d,",tbl[j]);
    }
    fprintf(f,"\n");
  }


}


void GenerateAttackes(void){
  int c0,i,sq,p,cntrl,j,*bit_atk,dP,n0,n1,u,d,p1;
    memset(p_attack,0,sizeof(struct Atk_Type)*2);
    for(c0 = WHITE; c0 <= BLACK; c0++){
      //c1 = c0 ^ 1;
      dP = c0==WHITE? -8:8;
      bit_atk = p_attack[c0].bit_atk;
      for(i = g.start[c0]; i <= g.stop[c0]; i++)
        if(  (sq = g.list[i]) != -1 ){
          p = g.pos[sq];
          cntrl = piece_cntrl[p];
          n0 = MAP(sq);
          if(p==PAWN){
             n1 = n0 + dP + dP - 1;
             if( (n1&0x88)==0 ){
               u = UNMAP(n1);
               bit_atk[u] = ++bit_atk[u] | cntrl;
             }
             n1 += 2;
             if( (n1&0x88)==0 ){
               u = UNMAP(n1);
               bit_atk[u] = ++bit_atk[u] | cntrl;
             }
          }else if(SWEEP(p)){//other pieces
//             extern int atk[16*16],dir_atk[16*16];
//             extern const int center;

             for(j = d_start[p]; j <= d_stop[p]; j++){
                d = dir[j];
                for(n1 = n0+d; (n1&0x88)==0; n1 += d){
                  u = UNMAP(n1);
                  bit_atk[u] = ++bit_atk[u] | cntrl;
                  p1 = g.pos[u];
                  if(p1==0) continue;
                  if( SWEEP(p1) && g.color[u]==c0 && (atk[n1-n0+center] & (1<<p1))){
                      for(n1 = n1+d; (n1&0x88)==0; n1 += d){
                         u = UNMAP(n1);
                         ++bit_atk[u];
                         if(g.pos[u]) break;
                      }
                  } //enif
                  break; //out for n1
                }//for n1
             }//for j
          }else{//KNIGHT, KING

             for(j = d_start[p]; j <= d_stop[p]; j++)
               if( ((n1 = n0+dir[j]) & 0x88) == 0 ){
                  u = UNMAP(n1);
                  bit_atk[u] = ++bit_atk[u] | cntrl;
               }
          }

        }
    }//for c
}



/*
  King safety
*/

int KingSFTY(int c){
   int sq = g.kingSq[c], c1 = c^1, n0 = MAP(sq),
       *a1 = p_attack[c1].bit_atk, *a0 = p_attack[c].bit_atk,
       dP = c==WHITE? -8:8, n1,d,u,j,score=0,cntMoveKing,
       fine,cntPawnScreen,findPawn,
       *hasOpponent = g.cnt[c1],
       *pDir,*pStop,
       cnt_check = 0,
       has_check = 0;
       
       
   double stage = Stage(c);

   if(stage==0) return 0;




  cntMoveKing = 0;
  findPawn = 0;
  cntPawnScreen = 0;
  
  pDir =  (int*)&dir[d_start[KING]];       // PAWN SCREEN
  pStop = pDir + 8; 
  do{  
     n1 = n0+(*pDir);
     if( (n1&0x88) == 0 ){
      int cntAtk;
      u = UNMAP(n1);
      
      cntAtk = a1[u] & 15;
      
      if( cntAtk )  score -= cntAtk;
      else if(g.color[u] != c) cntMoveKing++;  // <--- 0003
      
      if(g.pos[u] == PAWN && g.color[u] == c)
      {
        const int pscr[] = {4,6,2,0,0,2,6,4};
              
        findPawn = 1;
        if(c == WHITE){
          if(ROW(u) <  ROW(sq))
          {
             cntPawnScreen++;
             score += pscr[COLUMN(u)];                
          }
        }else{
          if(ROW(u) > ROW(sq))
          {
             cntPawnScreen++;
             score += pscr[COLUMN(u)];                
          }
        }
      }// pos[u]==PAWN
      
      
     }// n1 & 0x88
     pDir++;
  }while(   pDir <= pStop  );

  if(!findPawn) score -= 4;
  if(cntPawnScreen==0) score -= 8;
  
                                     // OPEN LINE
  

  if( g.pawn_column_cnt[c][COLUMN(sq)] == 0 ) score -= 4;


  
  if(a1[sq])                         //IN CHECK  
  {
    if(cntMoveKing==0)
      score -= 10; // mate ?  
  }
  

   

 if(hasOpponent[PAWN])                  // OPPONENT CAN CHECK ?
  if( (unsigned)(sq + dP) < 64 )
  { 
   if(  a1[ sq + dP]  & CNTRL_PAWN )   
   {
      score -= 4; // check ?
   }
  }  
   

   if(hasOpponent[BISHOP] | hasOpponent[QUEEN])
    for(j = d_start[BISHOP]; j <= d_stop[BISHOP]; j++){
     d = dir[j];
     for(n1 = n0+d; (n1&0x88)==0; n1+=d){
       u = UNMAP(n1);
       if(g.color[u] != c1){
         if(a1[u] & (CNTRL_BISHOP|CNTRL_QUEEN))
         {
            cnt_check++;
         }
       }
       if(g.color[u] != NEUTRAL) break;
     }
    }

   if(hasOpponent[ROOK] | hasOpponent[QUEEN])
    for(j = d_start[ROOK]; j <= d_stop[ROOK]; j++){
     d = dir[j];
     for(n1 = n0+d; (n1&0x88)==0; n1+=d){
       u = UNMAP(n1);
       if(g.color[u] != c1){
         if(a1[u] & (CNTRL_ROOK|CNTRL_QUEEN))
         {
            cnt_check++;
         }
       }
       if(g.color[u] != NEUTRAL) break;
     }
    }

  if(hasOpponent[KNIGHT])
    for(j = d_start[KNIGHT]; j <= d_stop[KNIGHT]; j++){
     if( ((n1 = n0+dir[j])&0x88)==0 ){
       u = UNMAP(n1);
       if(g.color[u] != c1)
         if(a1[u] & CNTRL_KNIGHT){
            cnt_check++;
         }
     }
    }



 if(cnt_check)
 {
   switch(cntMoveKing){
     case 0: 
       score -= 4;
       break;
     case 1:
       score -= 2;
       break;  
   }
   has_check = 1; 
 }
   
   


do{

  const int tbl[] = {0, 9, 19, 27, 35, 42, 49, 53, 57, 59, 60, 59, 57, 53, 49, 42, 35, 27, 19, 9, 0, 0, 0, 0, 0, 0, 0};
  
  score -= tbl[cnt_check];

}while(0);



  
   if(g.cnt[c1][QUEEN] && !g.casling[c]){
     int LeftCastlEnable( int c );
     int RightCastlEnable( int c );
                                        
     int l = LeftCastlEnable(c);
     int r = RightCastlEnable(c);
     if(l==0) score -= 2;
     if(r==0) score -= 4;
     if(l + r == 0) score -= 12;
   }
   
   
   if(g.casling[c]){
     if( COLUMN(sq) > 4 ) // o-o
         score += 8*stage;
     else                 // o-o-o
         score += 6*stage;             
   }   
   
   
   
   return (stage*score) + has_check;
   
}






int  Mobile_Pin_XRay(int sq, int p, int c, int* a0, int* a1, int *mob){
   int score = 0, mobile = 0, n0 = MAP(sq),n1,u,sq1,j,d;


   for(j = d_start[p]; j <= d_stop[p]; j++){
     d = dir[j];
     for(n1 = n0+d; (n1&0x88)==0; n1+=d){
        u = UNMAP(n1);
        if(g.pos[u]==0){
            mobile++;
            continue;
        }else{
        
//         if(g.color[u] != c) mobile++; // see <sq atk cnt> 
        
           if(g.pos[u]==PAWN || g.pos[u]==KING) break;
           sq1 = u;
           for(n1 = n1+d; (n1&0x88)==0; n1+=d){
              u = UNMAP(n1);
              if(g.pos[u]==0) continue;
              if(g.color[u]== (c^1)){
                  if(comp_value[g.pos[u]] > comp_value[p]  ||
                     a1[u]==0)
                  {
                  
                    // ----------------------------------
                    // sq ---> sq1 ------> u
                    // start   x_piece     target
                    //                     | PIN or XRAY
                    //
                    // a0 -     atk, tbl
                    // a1 - op. atk. tbl   
                    //-----------------------------------
                    

                     if(g.color[sq1]==c)  //XRAY 
                     {
                        score += 5;
                        if(g.pos[u]==KING) 
                        {
                           score += 3;         // MELNITHA ?
                           
                           //??
                           //printf("-->c=%d p=%d sq=%s \n", 
                           //       c, p, chb[sq]);  
                           
                           // threat++;       
                        }
                           
                     }else{               //PIN
                        score += 6;
                        if(g.pos[u]==KING){
                            score += 1;        // HARD 
                            if((a0[sq1] & 15) > 1) 
                              score += 1;      // WIN MATERIAL ?
                        }
                     }
                  }
              }
              break;
           }//for n1
           break;
        } //if not empty square
      }//for n1
   }//for j


   if(mob) *mob = mobile;

   
  
 
 /***************************
  if(p==BISHOP)
  {
    return  score - 3 + (sin((3.14/2/15)*mobile) * 14);
  }else if(p==ROOK){
    return  score - 2 + (sin((3.14/2/16)*mobile) * 12);
  }else{//queen
    return  score - 1  + (sin((3.14/2/31)*mobile) * 8);
  }
  ***********************/
  
   
// !!! ADD mobile for capture ?
//  
//                                     B     R        B_max  R_max
//                                     |     |        |     |
//         0  1  2  3  4  5  6  7  8  9  10 11 12 13 14 15 16
   do{     
int rm[]= {0, 1, 2, 3, 4, 5, 5, 6, 7, 8, 8, 9, 9, 9, 10, 10, 10, 10, 10, 10};
int bm[]= {0, 1, 2, 4, 5, 6, 7, 8, 9,10,10,11,11,12, 12, 12, 12, 12, 12 };
int qm[]= {0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3,  3,  4,  4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6 };
int *mob_table[] = {0, 0, 0, bm, rm, qm, 0};
//                     p  n   b   r   q  k 


   return score -3 + mob_table[p][mobile];
   }while(0);
//               |
//              (bishop+mob) AND knight?             
}


